use warnings;
use strict;
use Test::More tests => 12;
use Test::Exception;

use POWER::Utils;

my ($out, @out, $TempFile, @expect, $expect);

$out    = Cat("/dev/null");
is($out, '',                "'' from /dev/null");

@out    = Cat("/dev/null");
is(@out, 0,                 "() from /dev/null");

$TempFile = "tmp.dat";

@expect = ("line1\n", "line2\n", "line3");
$expect = join "", @expect;
open TMP, ">$TempFile" or die $@; print TMP $expect; close TMP;
$out    = Cat($TempFile);
is($out, $expect,           "3 lines without CR, as scalar");

@out    = Cat($TempFile);
is(@out, @expect,           "3 lines without CR, as list");

is(join("",@out), $expect,  "3 lines without CR, as joined list");

@expect = ("line1\n", "line2\n", "line3\n");
$expect = join "", @expect;
open TMP, ">tmp.dat" or die $@; print TMP $expect; close TMP;
$out    = Cat($TempFile);
is($out, $expect,           "3 lines with CR, as scalar");

@out    = Cat($TempFile);
is(@out, @expect,           "3 lines with CR, as list");

is(join("",@out), $expect,  "3 lines with CR, as joined list");

{ local $/;
@out    = Cat($TempFile);
is(@out, 1,                 "3 lines with CR, as list, \$\/ undefined");

$out    = Cat($TempFile);
is($out, $expect,           "3 lines with CR, as scalar, \$\/ undefined");
} # local $/

unlink $TempFile;

throws_ok { Cat($TempFile)      } qr/open:/;
throws_ok { Cat(">$TempFile")   } qr/open:/;

